## alljoyn-thin-client-1604 16.04

=== Makefile ===
# Copyright AllSeen Alliance. All rights reserved.
#
#    Permission to use, copy, modify, and/or distribute this software for any
#    purpose with or without fee is hereby granted, provided that the above
#    copyright notice and this permission notice appear in all copies.
#
#    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
#    WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
#    MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
#    ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
#    WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
#    ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
#    OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

#
# This makefile is meant to be used solely for building WSL-enabled applications.
# It is intended to be invoked from IDEs that do not support building using SCons.
# All paths in this file are relative to the makefile location
#
# Some care has to be taken when passing string values into the makefile from the command-line.
# An extra level of backslash escaping required to get a string presented to the compiler's preprocessor.
# For example, passing the string "bar" to use as a character string initializer in a .c file:
#    const char foo_var[] = FOO_VAR;
#
# Is passed on the command line:
#    make target FOO_VAR=\\\"bar\\\"
#
# Which results in compiler arguments such as:
#    -DFOO_VAR=\"bar\"
#
# settings that can be defined:
#   AJ_CONFIGURE_WIFI_UPON_START: (boolean) should wifi network connections be started when the AllJoyn
#            application starts, 1 means yes, 0 or undef means no
#            example: AJ_CONFIGURE_WIFI_UPON_START=1
#   WIFI_DEVICE_NAME: (quoted string) the hostname to assign to your device when connecting to the network
#            example: WIFI_DEVICE_NAME=\\\"WSLNode001\\\"
#   WIFI_SCAN: (boolean) should a scan of access points be performed when the device starts up,
#            1 means yes, 0 or undef means no
#            example: WIFI_SCAN=1
#   WIFI_SSID: (quoted string) the SSID of the network to connect to
#            example: WIFI_SSID=\\\"AP_SSID01\\\"
#   WIFI_PASSPHRASE: (quoted string) the passphrase used to connect to WIFI_SSID
#            example: WIFI_PASSPHRASE=\\\"PassPhrase\\\"
#   SOFTAP_SSID: (quoted string) the SSID to use when the device is put into Access Point mode
#            example: SOFTAP_SSID=\\\"SoftAP_SSID01\\\"
#   SOFTAP_PASSPHRASE: (quoted string) the passphrase needed by clients to connect to SOFTAP_SSID
#            example: SOFTAP_PASSPHRASE=\\\"My_PassPhrase\\\"

ALLJOYN_DEFINES =

# Check which options are defined on the command-line
ifneq ($(AJ_DEBUG_RESTRICT), )
ALLJOYN_DEFINES += -DAJ_DEBUG_RESTRICT=${AJ_DEBUG_RESTRICT}
endif

ifneq ($(AJ_CONFIGURE_WIFI_UPON_START), )
ALLJOYN_DEFINES += -DAJ_CONFIGURE_WIFI_UPON_START=${AJ_CONFIGURE_WIFI_UPON_START}
endif

ifneq ($(WIFI_DEVICE_NAME),)
ALLJOYN_DEFINES += -DWIFI_DEVICE_NAME=${WIFI_DEVICE_NAME}
endif

ifneq ($(WIFI_SCAN),)
ALLJOYN_DEFINES += -DWIFI_SCAN=${WIFI_SCAN}
endif

ifneq ($(WIFI_SSID),)
ALLJOYN_DEFINES += -DWIFI_SSID=${WIFI_SSID}
endif

ifneq ($(WIFI_PASSPHRASE),)
ALLJOYN_DEFINES += -DWIFI_PASSPHRASE=${WIFI_PASSPHRASE}
endif

ifneq ($(SOFTAP_SSID),)
ALLJOYN_DEFINES += -DSOFTAP_SSID=${SOFTAP_SSID}
endif

ifneq ($(SOFTAP_PASSPHRASE),)
ALLJOYN_DEFINES += -DSOFTAP_PASSPHRASE=${SOFTAP_PASSPHRASE}
endif


DEFINES = 	-D__SAM3X8E__ \
			-DARM_MATH_CM3=true \
			-DBOARD=ARDUINO_DUE_X \
			-Dprintf=iprintf 

DEFINES += $(ALLJOYN_DEFINES)



RELEASE_DEFINES = 	-DNDEBUG \


# Linker flags
LDFLAGS = 	-mthumb \
			-Wl,-Map=$@.map \
			-Wl,--start-group \
			-larm_cortexM3l_math \
			-lm \
			-Wl,--end-group \
			-L"$(ATMEL_DIR)/thirdparty/CMSIS/Lib/GCC" \
			-Wl,--gc-sections \
			-mcpu=cortex-m3 \
			-Wl,--entry=Reset_Handler \
			-Wl,--cref \
			-mthumb \
			-T$(ATMEL_DIR)/sam/utils/linker_scripts/sam3x/sam3x8/gcc/flash.ld 

RELEASE_LDFLAGS = \
			-Os \


# Include Paths
INCLUDES = 	-I. \
			-Iconfig \
			-I$(FREE_RTOS_DIR)/Source/include \
			-I$(FREE_RTOS_DIR)/Source/portable/GCC/ARM_CM3 \
			-I$(ATMEL_DIR)/common/boards \
			-I$(ATMEL_DIR)/common/services/clock \
			-I$(ATMEL_DIR)/common/services/clock/sam3x \
			-I$(ATMEL_DIR)/common/services/gpio \
			-I$(ATMEL_DIR)/common/services/ioport \
			-I$(ATMEL_DIR)/common/services/freertos/sam \
			-I$(ATMEL_DIR)/common/services/serial/sam_uart \
			-I$(ATMEL_DIR)/common/services/serial \
			-I$(ATMEL_DIR)/common/services/spi \
			-I$(ATMEL_DIR)/common/services/sam_spi \
			-I$(ATMEL_DIR)/common/services/spi/sam_spi/module_config \
			-I$(ATMEL_DIR)/common/utils \
			-I$(ATMEL_DIR)/common/utils/stdio/stdio_serial \
			-I$(ATMEL_DIR)/common/drivers/nvm \
			-I$(ATMEL_DIR)/common/drivers/nvm/sam/module_config \
			-I$(ATMEL_DIR)/sam/boards \
			-I$(ATMEL_DIR)/sam/boards/arduino_due_x \
			-I$(ATMEL_DIR)/sam/drivers/dmac \
			-I$(ATMEL_DIR)/sam/drivers/pio \
			-I$(ATMEL_DIR)/sam/drivers/pmc \
			-I$(ATMEL_DIR)/sam/drivers/pdc \
			-I$(ATMEL_DIR)/sam/drivers/uart \
			-I$(ATMEL_DIR)/sam/drivers/usart \
			-I$(ATMEL_DIR)/sam/drivers/spi \
			-I$(ATMEL_DIR)/sam/drivers/efc \
			-I$(ATMEL_DIR)/sam/drivers/trng \
			-I$(ATMEL_DIR)/sam/utils \
			-I$(ATMEL_DIR)/sam/utils/cmsis/sam3x/include \
			-I$(ATMEL_DIR)/sam/utils/cmsis/sam3x/source/templates \
			-I$(ATMEL_DIR)/sam/utils/cmsis/sam3x/include/component \
			-I$(ATMEL_DIR)/sam/utils/header_files \
			-I$(ATMEL_DIR)/sam/utils/preprocessor \
			-I$(ATMEL_DIR)/sam/services/flash_efc \
			-I$(ATMEL_DIR)/thirdparty/CMSIS/Include \
			-I$(ATMEL_DIR)/thirdparty/CMSIS/Lib/GCC \
			-I$(ATMEL_DIR)/sam/boards/arduino_due_x/board_config \
			-I$(ATMEL_DIR)/common/services/clock/sam3x/module_config \
			-I$(ATMEL_DIR)/config \
			-I$(ATMEL_DIR)/common/services/clock/sam3x \
			-Iinc \
			-IRTOS \
			-IRTOS/FreeRTOS \
			-Ibsp \
			-Ibsp/due \
			-Ibsp/due/config \
			-Imalloc \
			-Iexternal\sha2 \
			-Icrypto \
			-Icrypto/ecc \
			-IWSL
	
# Compiler flags	
FLAGS = 	-mthumb \
			-fdata-sections \
			-ffunction-sections \
			-mlong-calls \
			-g3 \
			-Wall \
			-mcpu=cortex-m3 \
			-c \
			-pipe \
			-fno-strict-aliasing \
			-Wpointer-arith \
			-std=gnu99 \
			-Wchar-subscripts \
			-Wcomment \
			-Wformat=2 \
			-Wimplicit-int \
			-Wmain \
			-Wparentheses \
			-Wsequence-point \
			-Wreturn-type \
			-Wswitch \
			-Wtrigraphs \
			-Wunused \
			-Wuninitialized \
			-Wfloat-equal \
			-Wundef \
			-Wshadow \
			-Wbad-function-cast \
			-Wwrite-strings \
			-Wsign-compare \
			-Waggregate-return \
			-Wformat \
			-Wno-deprecated-declarations \
			-Wno-unknown-pragmas \
			-Wpacked \
			-Wunreachable-code \
			-Wcast-align \
			--param max-inline-insns-single=500 \
			-MD \
			-MP \
			-MF $(@:%.o=%.d)


			
COMPILER = arm-none-eabi-gcc.exe

SOURCE_FILES :=	$(FREE_RTOS_DIR)/Source/croutine.c \
				$(FREE_RTOS_DIR)/Source/list.c \
				$(FREE_RTOS_DIR)/Source/queue.c \
				$(FREE_RTOS_DIR)/Source/tasks.c \
				$(FREE_RTOS_DIR)/Source/timers.c \
				$(FREE_RTOS_DIR)/Source/portable/MemMang/heap_3.c \
				$(FREE_RTOS_DIR)/Source/portable/GCC/ARM_CM3/port.c \
				$(ATMEL_DIR)/common/services/clock/sam3x/sysclk.c \
				$(ATMEL_DIR)/common/services/spi/sam_spi/spi_master.c \
				$(ATMEL_DIR)/common/services/freertos/sam/freertos_peripheral_control.c \
				$(ATMEL_DIR)/common/services/freertos/sam/freertos_usart_serial.c \
				$(ATMEL_DIR)/common/utils/interrupt/interrupt_sam_nvic.c \
				$(ATMEL_DIR)/common/utils/stdio/read.c \
				$(ATMEL_DIR)/common/utils/stdio/write.c \
				$(ATMEL_DIR)/common/drivers/nvm/sam/sam_nvm.c \
				$(ATMEL_DIR)/sam/boards/arduino_due_x/init.c \
				$(ATMEL_DIR)/sam/boards/arduino_due_x/led.c \
				$(ATMEL_DIR)/sam/drivers/dmac/dmac.c \
				$(ATMEL_DIR)/sam/drivers/pdc/pdc.c \
				$(ATMEL_DIR)/sam/drivers/pio/pio.c \
				$(ATMEL_DIR)/sam/drivers/pio/pio_handler.c \
				$(ATMEL_DIR)/sam/drivers/pmc/pmc.c \
				$(ATMEL_DIR)/sam/drivers/pmc/sleep.c \
				$(ATMEL_DIR)/sam/drivers/uart/uart.c \
				$(ATMEL_DIR)/sam/drivers/usart/usart.c \
				$(ATMEL_DIR)/sam/drivers/spi/spi.c \
				$(ATMEL_DIR)/sam/drivers/efc/efc.c \
				$(ATMEL_DIR)/sam/drivers/trng/trng.c \
				$(ATMEL_DIR)/sam/utils/cmsis/sam3x/source/templates/exceptions.c \
				$(ATMEL_DIR)/sam/utils/cmsis/sam3x/source/templates/system_sam3x.c \
				$(ATMEL_DIR)/sam/utils/cmsis/sam3x/source/templates/gcc/startup_sam3x.c \
				$(ATMEL_DIR)/sam/services/flash_efc/flash_efc.c \
				$(ATMEL_DIR)/sam/utils/syscalls/gcc/syscalls.c \
				crypto/aj_sw_crypto.c \
				crypto/ecc/aj_crypto_ecc.c \
				crypto/ecc/aj_crypto_sha2.c \
				src/aj_about.c \
				src/aj_bufio.c \
				src/aj_bus.c \
				src/aj_connect.c \
				src/aj_cert.c \
				src/aj_crc16.c \
				src/aj_creds.c \
				src/aj_crypto.c \
				src/aj_debug.c \
				src/aj_disco.c \
				src/aj_guid.c \
				src/aj_helper.c \
				src/aj_init.c \
				src/aj_introspect.c \
				src/aj_keyauthentication.c \
				src/aj_keyexchange.c \
				src/aj_link_timeout.c \
				src/aj_msg.c \
				src/aj_nvram.c \
				src/aj_peer.c \
				src/aj_serial.c \
				src/aj_serial_rx.c \
				src/aj_serial_tx.c \
				src/aj_std.c \
				src/aj_util.c \
				malloc/aj_malloc.c \
				external/sha2/sha2.c \
				WSL/aj_buf.c \
				WSL/aj_wsl_htc.c \
				WSL/aj_wsl_net.c \
				WSL/aj_wsl_spi_mbox.c \
				WSL/aj_wsl_unmarshal.c \
				WSL/aj_wsl_wmi.c \
				WSL/aj_wsl_marshal.c \
				WSL/aj_wsl_tasks.c \
				RTOS/main.c \
				RTOS/aj_net.c \
				RTOS/aj_wifi_ctrl.c \
				RTOS/Alljoyn.c \
				RTOS/FreeRTOS/aj_target_rtos.c \
				bsp/due/aj_spi.c \
				bsp/due/aj_trng.c \
				bsp/due/aj_target_platform.c


TEST_FILES = 	test/aestest.c
TEST_FILES +=	test/mutter.c
TEST_FILES +=	test/svclite.c
TEST_FILES +=	test/nvramtest.c
TEST_FILES += 	test/clientlite.c
TEST_FILES += 	test/sessionslite.c

		
SAMPLE_FILES =  	samples/basic/basic_client.c
SAMPLE_FILES += 	samples/basic/basic_service.c
SAMPLE_FILES += 	samples/basic/nameChange_client.c
SAMPLE_FILES += 	samples/basic/signalConsumer_client.c
SAMPLE_FILES += 	samples/basic/signal_service.c
SAMPLE_FILES += 	samples/secure/SecureClient.c

OBJECTS = $(SOURCE_FILES:.c=.o)
TEST_OBJECTS = $(TEST_FILES:.c=.o)
SAMPLE_OBJECTS = $(SAMPLE_FILES:.c=.o)
DFILES = $(SOURCE_FILES:.c=.d)
EXECUTABLES = $(TEST_FILES:.c=.elf)

test: $(TEST_FILES) $(TEST_OBJECTS) $(OBJECTS)
sample: $(SAMPLE_FILES) $(SAMPLE_OBJECTS) $(OBJECTS)




Release: release
#release: FLAGS += -O3
release: DEFINES += -DNDEBUG
release: all

Debug: debug
#debug: FLAGS += -g3
debug: all


# All the test elf's are linked here. Add more by using the same format as the others
# $(COMPILER) -o <name_of_elf>.elf $(OBJECTS) <any_extra_files_with_main()>.o $(LDFLAGS)
all: test \
	sample \
	due_mutter \
	due_svclite \
	due_nvram_test \
	due_clientlite \
	due_sessionslite \
	due_basic_client \
	due_basic_service \

due_aestest:
	$(COMPILER) -o due_aestest.elf $(OBJECTS) test/aestest.o $(LDFLAGS)

due_mutter:
	$(COMPILER) -o due_mutter.elf $(OBJECTS) test/mutter.o $(LDFLAGS)

due_svclite:
	$(COMPILER) -o due_svclite.elf $(OBJECTS) test/svclite.o $(LDFLAGS)
	
due_nvram_test:
	$(COMPILER) -o due_nvram_test.elf $(OBJECTS) test/nvramtest.o $(LDFLAGS)

due_clientlite:
	$(COMPILER) -o due_clientlite.elf $(OBJECTS) test/clientlite.o $(LDFLAGS)

due_sessionslite:
	$(COMPILER) -o due_sessionslite.elf $(OBJECTS) test/sessionslite.o $(LDFLAGS)

due_samplesecureclient:
	$(COMPILER) -o due_samplesecureclient.elf $(OBJECTS) samples/secure/secureclient.o $(LDFLAGS)

due_samplesecureservice:
	$(COMPILER) -o due_samplesecureservice.elf $(OBJECTS) samples/secure/secureservice.o $(LDFLAGS)


due_basic_client:
	$(COMPILER) -o due_basic_client.elf $(OBJECTS) samples/basic/basic_client.o $(LDFLAGS)

due_basic_service:
	$(COMPILER) -o due_basic_service.elf $(OBJECTS) samples/basic/basic_service.o $(LDFLAGS)

due_nameChange_client:
	$(COMPILER) -o due_nameChange_client.elf $(OBJECTS) samples/basic/nameChange_client.o $(LDFLAGS)

=== SConstruct ===
import os
import platform
import re

#######################################################
# Custom Configure functions
#######################################################
def CheckCommand(context, cmd):
    context.Message('Checking for %s command...' % cmd)
    r = WhereIs(cmd)
    context.Result(r is not None)
    return r

def CheckAJLib(context, ajlib, ajheader, sconsvarname, ajdistpath):
    prog = "#include <%s>\nint main(void) { return 0; }" % ajheader
    context.Message('Checking for AllJoyn library %s...' % ajlib)

    prevLIBS = context.env['LIBS']
    prevLIBPATH = context.env.get('LIBPATH', [])
    prevCPPPATH = context.env.get('CPPPATH', [])

    # Check if library is in standard system locations
    context.env.Append(LIBS = ajlib)
    defpath = ''  # default path is a system directory
    if not context.TryLink(prog, '.c'):
        # Check if library is in project default location
        context.env.Append(LIBPATH = ajdistpath + '/lib', CPPPATH = ajdistpath + '/include')
        if context.TryLink(prog, '.c'):
            defpath = ajdistpath  # default path is the dist directory
        # Remove project default location from LIBPATH and CPPPATH
        context.env.Replace(LIBPATH = prevLIBPATH, CPPPATH = prevCPPPATH)

    vars = Variables()
    vars.Add(PathVariable(sconsvarname,
                          'Path to %s dist directory' % ajlib,
                          os.environ.get('AJ_%s' % sconsvarname, defpath),
                          lambda k, v, e : v == '' or PathVariable.PathIsDir(k, v, e)))
    vars.Update(context.env)
    Help(vars.GenerateHelpText(context.env))

    # Get the actual library path to use ('' == system path, may be same as ajdistpath)
    libpath = env.get(sconsvarname, '')
    if libpath is not '':
        libpath = str(context.env.Dir(libpath))
        # Add the user specified (or ajdistpath) to LIBPATH and CPPPATH
        context.env.Append(LIBPATH = libpath + '/lib', CPPPATH = libpath + '/include')

    # The real test for the library
    r = context.TryLink(prog, '.c')
    if not r:
        context.env.Replace(LIBS = prevLIBS, LIBPATH = prevLIBPATH, CPPPATH = prevCPPPATH)
    context.Result(r)
    return r

#######################################################
# Default target platform
#######################################################
if platform.system() == 'Linux':
    default_target = 'linux'
elif platform.system() == 'Windows':
    default_target = 'win32'
elif platform.system() == 'Darwin':
    default_target = 'darwin'

#######################################################
# Build variables
#######################################################
debug_restrict_options = (
    '0', 'AJ_DEBUG_OFF',
    '1', 'AJ_DEBUG_ERROR',
    '2', 'AJ_DEBUG_WARN',
    '3', 'AJ_DEBUG_INFO',
    '4', 'AJ_DEBUG_DUMP',
    '5', 'AJ_DEBUG_ALL'
)
target_options = [ t.split('.')[-1] for t in os.listdir('.') if re.match('^SConscript\.target\.[-_0-9A-Za-z]+$', t) ]

vars = Variables()
vars.Add(BoolVariable('V',              'Build verbosity',             False))
vars.Add(EnumVariable('TARG',           'Target platform variant',     os.environ.get('AJ_TARG', default_target), allowed_values = target_options))
vars.Add(EnumVariable('VARIANT',        'Build variant',               os.environ.get('AJ_VARIANT', 'debug'),     allowed_values = ('debug', 'release')))
vars.Add(EnumVariable('DEBUG_RESTRICT', 'Set compiled in debug level', os.environ.get('AJ_DEBUG_RESTRICT'),       allowed_values = debug_restrict_options))
vars.Add('CC',  'C Compiler override')
vars.Add('CXX', 'C++ Compiler override')
vars.Add(EnumVariable('NDEBUG', 'Override NDEBUG default for release variant', 'defined', allowed_values=('defined', 'undefined')))

if platform.system() != 'Windows':
    env = Environment(variables = vars)
else:
    if platform.machine() != 'AMD64':
        target_arch = 'x86'
    else:
        environment_force32 = os.environ.get('AJ_FORCE32', False)
        vars.Add(BoolVariable('FORCE32', 'Force building 32 bit on 64 bit architecture', environment_force32))

        if environment_force32:
            default_force32 = 'true'
        else:
            default_force32 = 'false'

        force32 = ARGUMENTS.get('FORCE32', default_force32)
        force32 = force32.lower()

        if force32 == 'true' or force32 == 'yes' or force32 == '1':
            target_arch = 'x86'
        else:
            target_arch = 'x86_64'

    # Target CPU architecture must be specified here for Windows - otherwise platform.machine() is always used as the target!
    env = Environment(variables = vars, TARGET_ARCH=target_arch)

Export('env')
Help(vars.GenerateHelpText(env))

#######################################################
# Setup non-verbose output
#######################################################
if not env['V']:
    env.Replace( CCCOMSTR =     '\t[CC]      $SOURCE',
                 SHCCCOMSTR =   '\t[CC-SH]   $SOURCE',
                 CXXCOMSTR =    '\t[CXX]     $SOURCE',
                 SHCXXCOMSTR =  '\t[CXX-SH]  $SOURCE',
                 LINKCOMSTR =   '\t[LINK]    $TARGET',
                 SHLINKCOMSTR = '\t[LINK-SH] $TARGET',
                 JAVACCOMSTR =  '\t[JAVAC]   $SOURCE',
                 JARCOMSTR =    '\t[JAR]     $TARGET',
                 ARCOMSTR =     '\t[AR]      $TARGET',
                 ASCOMSTR =     '\t[AS]      $TARGET',
                 RANLIBCOMSTR = '\t[RANLIB]  $TARGET',
                 INSTALLSTR =   '\t[INSTALL] $TARGET',
                 WSCOMSTR =     '\t[WS]      $WS' )

#######################################################
# Load target setup
#######################################################
env['build'] = True
env['build_shared'] = False
env['build_unit_tests'] = True
env['connectivity_options'] = [ 'tcp' ]

env.SConscript('SConscript.target.$TARG')

vars = Variables()
vars.Add('CONNECTIVITY', 'Connectivity mechanism to connect to a routing node (any of ' + ', '.join(env['connectivity_options']) + ')', os.environ.get('AJ_CONNECTIVITY', ' '.join(env['connectivity_options'])))
vars.Update(env)
Help(vars.GenerateHelpText(env))
env['connectivity'] = [ opt.upper() for opt in env['connectivity_options'] if opt in env['CONNECTIVITY'].lower() ]

if len(env['connectivity']) == 0 and not GetOption('help'):
    print '*** Must enable at least one of %s' % ', '.join(env['connectivity_options'])
    Exit(1)

#######################################################
# Build Configuration
#######################################################
config = Configure(env, custom_tests = { 'CheckCommand' : CheckCommand,
                                         'CheckAJLib' : CheckAJLib })
found_ws = config.CheckCommand('uncrustify')
env = config.Finish()

#######################################################
# Compilation defines
#######################################################
if env.has_key('DEBUG_RESTRICT'):
    env.Append(CPPDEFINES = { 'AJ_DEBUG_RESTRICT' : env['DEBUG_RESTRICT'] })
if env['VARIANT'] == 'release' and env['NDEBUG'] == 'defined':
    env.Append(CPPDEFINES = [ 'NDEBUG' ])

env.Append(CPPDEFINES = [ 'AJ_' + conn for conn in env['connectivity'] ])

#######################################################
# Include path
#######################################################
env.Append(CPPPATH = [ '#dist/include' ])

#######################################################
# Process commandline defines
#######################################################
env.Append(CPPDEFINES = [ v for k, v in ARGLIST if k.lower() == 'define' ])

#######################################################
# Install header files
#######################################################
env.Install('#dist/include/ajtcl', env.Glob('inc/*.h'))
env.Install('#dist/include/ajtcl', env.Glob('src/target/$TARG/aj_target.h'))
# Need to force a dpendency here because SCons can't follow nested
# #include dependencies otherwise
env.Depends('#build/$VARIANT', '#dist/include')

# Install service headers
env.Install('#dist/include/ajtcl/services', env.Glob('services/common/inc/*.h'))
env.Install('#dist/include/ajtcl/services', env.Glob('services/config/inc/*.h'))

#######################################################
# Build the various parts
#######################################################
if env['build']:
    env.SConscript('src/SConscript',       variant_dir='#build/$VARIANT/src',       duplicate = 0)
    env.SConscript('samples/SConscript',   variant_dir='#build/$VARIANT/samples',   duplicate = 0)
    env.SConscript('test/SConscript',      variant_dir='#build/$VARIANT/test',      duplicate = 0)
    env.SConscript('unit_test/SConscript', variant_dir='#build/$VARIANT/unit_test', duplicate = 0)

    # Build ConfigService
    env.SConscript('services/common/src/SConscript.config', variant_dir='#build/$VARIANT/services/common/config/src', duplicate = 0)
    env.SConscript('services/config/src/SConscript',        variant_dir='#build/$VARIANT/services/config/src',        duplicate = 0)
    env.SConscript('services/config/samples/SConscript',    variant_dir='#build/$VARIANT/services/config/samples',    duplicate = 0)

#######################################################
# Run the whitespace checker
#######################################################
# Set the location of the uncrustify config file
if found_ws:
    import sys
    sys.path.append(os.getcwd() + '/tools')
    import whitespace

    def wsbuild(target, source, env):
        return whitespace.main([ env['WS'], os.getcwd() + '/tools/ajuncrustify.cfg' ])

    vars = Variables()
    vars.Add(EnumVariable('WS', 'Whitespace Policy Checker', os.environ.get('AJ_WS', 'off'), allowed_values = ('check', 'detail', 'fix', 'off')))

    vars.Update(config.env)
    Help(vars.GenerateHelpText(config.env))

    if env.get('WS', 'off') != 'off':
        env.Command('#ws_ajtcl', '#dist', Action(wsbuild, '$WSCOMSTR'))

=== debian/changelog ===
alljoyn-thin-client-1604 (16.04-2ubuntu1) artful; urgency=medium

  * debian/patches/link-pthread.patch: Add -pthread to LINKFLAGS to fix FTBFS.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 20 Jun 2017 22:44:48 -0700

alljoyn-thin-client-1604 (16.04-2) unstable; urgency=medium

  * move package to debian-iot-maintainer
  * add VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 26 Dec 2016 11:28:32 +0100

alljoyn-thin-client-1604 (16.04-1) unstable; urgency=medium

  * Initial release (Closes: #828130)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 25 Jun 2016 12:28:32 +0200

=== debian/control ===
Source: alljoyn-thin-client-1604
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: dh-exec (>=0.3)
               , debhelper (>=9)
	       , liballjoyn-common-dev-1604
	       , liballjoyn-dev-1604
               , scons
               , libssl-dev
               , libgtest-dev
#	       , javahelper
#	       , junit
#	       , libcsv-java
#	       , libmatthew-debug-java
#	       , libitext-java
#               , ant
#               , libcap-dev
Standards-Version: 3.9.8
Homepage: https://allseenalliance.org/framework
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/alljoyn-thin-client-1604.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/alljoyn-thin-client-1604.git

Package: alljoyn-thin-client-1604
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libajtcl1604 (= ${binary:Version})
Description: AllJoyn thin client for 1604
 AllJoyn is a collaborative open-source software framework that makes 
 it easy for developers to write applications that can discover nearby
 devices, and communicate with each other directly regardless of 
 brands, categories, transports, and OSes without the need of the cloud. 
 .
 The AllJoyn framework is extremely flexible with many features to help 
 make the vision of the Internet of Things come to life.
 .
 This package contains the software for the thin-client 
 in version 1604.


# this package name is the upstream soname
Package: libajtcl1604
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AllJoyn thin client library
 AllJoyn is a collaborative open-source software framework that makes 
 it easy for developers to write applications that can discover nearby
 devices, and communicate with each other directly regardless of 
 brands, categories, transports, and OSes without the need of the cloud. 
 .
 The AllJoyn framework is extremely flexible with many features to help 
 make the vision of the Internet of Things come to life.
 .
 This package contains the libraries for the thin client
 in version 1604.

Package: liballjoyntcl-dev-1604
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libajtcl1604 (= ${binary:Version}),
         liballjoyn-common-dev-1604
Section: libdevel
Description: AllJoyn thin client C++ development library
 AllJoyn is a collaborative open-source software framework that makes
 it easy for developers to write applications that can discover nearby
 devices, and communicate with each other directly regardless of
 brands, categories, transports, and OSes without the need of the cloud.
 .
 The AllJoyn framework is extremely flexible with many features to help
 make the vision of the Internet of Things come to life.
 .
 This package contains the C++ development files for the thin client.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export JAVA_HOME=/usr/lib/jvm/default-java
export CLASSPATH=/usr/share/java/csv.jar:/usr/share/java/debug-disable.jar:/usr/share/java/itext.jar
export GTEST_DIR=/usr/src/gtest

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# mapping all i.86 to x86 for Alljoyn
CPU=$(shell dpkg-architecture -qDEB_HOST_GNU_CPU | sed -e 's/i.86/x86/')
OS=linux
TARG=linux

export VERSION := 16.04
export SONAME := 1604
export VARIANT := release
export SCONS_ARGS := CPU=$(CPU) TARG=$(TARG) VARIANT=$(VARIANT) V=1 GTEST_DIR=$(GTEST_DIR)
export BUILD_DIR := $(CURDIR)/build/$(OS)/$(CPU)/$(VARIANT)/dist
export OBJ_DIR := $(CURDIR)/build/$(OS)/$(CPU)/$(VARIANT)/obj

%:
	dh $@

override_dh_auto_build:
	scons BINDINGS=cpp $(SCONS_ARGS) \
		WS=off BT=off ICE=off 

	touch ./to-be.removed-now.md5
	find ./* |grep '\.md5'|xargs rm

	dh_auto_build

override_dh_auto_clean:
	rm -f .sconsign.dblite
	rm -rf .sconf_temp
	rm -f config.log
	rm -rf dist
	touch ./to-be.removed-now.md5
	find ./* |grep '\.md5'|xargs rm
	touch ./to-be.removed-now.os
	find ./* |grep '\.os'|xargs rm
	touch ./to-be.removed-now.o
	find ./* |grep '\.o'|xargs rm
	rm -rf build
	dh_auto_clean

override_dh_install:
	dh_install
	## improve stuff
	#chmod 644 debian/alljoyn-services-1509/etc/alljoyn/*.conf

=== debian/watch ===
version=3
opts="dversionmangle=s/core/alljoyn-thin-client/" \
https://git.allseenalliance.org/cgit/core/ajtcl.git/ /cgit/core/ajtcl.git/snapshot/ajtcl-(16\.04?)\.tar\.gz
